unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, GLScene, GLObjects, GLCadencer, GLTexture, GLMisc, GLWin32Viewer, jpeg;

type
  TForm1 = class(TForm)
    GLScene1: TGLScene;
    GLSceneViewer1: TGLSceneViewer;
    GLCamera1: TGLCamera;
    GLLightSource1: TGLLightSource;
    GLMaterialLibrary1: TGLMaterialLibrary;
    GLCadencer1: TGLCadencer;
    Tabla: TGLDummyCube;
    procedure FormCreate(Sender: TObject);
    procedure GLSceneViewer1MouseDown(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure GLCadencer1Progress(Sender: TObject; const deltaTime,
      newTime: Double);
  private
    procedure Proveri;
    { Private declarations }
  public
    { Public declarations }
    procedure NovaIgra;
  end;

var
  Form1: TForm1;
  Okretanje: Boolean;
  Izabrana1, Izabrana2: TGLDummyCube;
  Pauza: Boolean;
  Vracanje: Boolean;
  Cekanje: Double;
  Nestajanje: Boolean;
  MatBoja, MatFade: TGLMaterial;

implementation

{$R *.dfm}

procedure TForm1.Proveri;
begin
 // Ako su boje iste vreme je za "nestajanje" :)
  Nestajanje :=
  TGLCube(Izabrana1.Children[1]).Material.LibMaterialName =
  TGLCube(Izabrana2.Children[1]).Material.LibMaterialName;
  // Ako nisu ista onda ih vracamo
  Vracanje := not Nestajanje;
  if Nestajanje then
  begin
    // Postavljamo material za nestajanje
    TGLCube(Izabrana1.Children[0]).Material.LibMaterialName := 'FadeOut';
    TGLCube(Izabrana2.Children[0]).Material.LibMaterialName := 'FadeOut';
    // Uzimamo materijal za boju kako bismo mogli
    // polako da ga napraimo providnim
    MatBoja := GLMaterialLibrary1.LibMaterialByName(
      TGLCube(Izabrana1.Children[1]).Material.LibMaterialName).Material;
  end;
end;

procedure TForm1.NovaIgra;
var
  X, Y: Integer;
  Mat: array[0..11] of String;
  Dummy: TGLDummyCube;
  Cube: TGLCube;

  // Izabira material za polje
  function IzaberiMaterijal: String;
  var
    I: Integer;
  begin
    I := Random(12 - (X + (Y * 4)));
    Result := Mat[I];
    Mat[I] := Mat[11 - (X + (Y * 4))];
  end;

begin
  // Brisemo sve objekte u Tabla
  Tabla.DeleteChildren;

  // Postavljamo boje za IzaberiMaterijal
  for X := 0 to 5 do
  begin
    Mat[X] := IntToStr(X);
    Mat[X + 6] := IntToStr(X);
  end;

  // Postavljamo plocice na tablu
  for Y := 0 to 2 do
    for X := 0 to 3 do
    begin
      // Dodajemo jedan DummyCube koji ce drzati
      // pozadinu (kocku bez jedne strane) i
      // zadnju stranu koja je obojena
      Dummy := TGLDummyCube.CreateAsChild(Tabla);
      Dummy.Position.SetPoint(-3 + X * 2, -1.5 + Y * 1.5, 0);
      // Dodajemo pozadinu
      Cube := TGLCube.CreateAsChild(Dummy);
      Cube.CubeDepth := 0.2;
      Cube.Parts := Cube.Parts - [cpBack];
      Cube.Material.MaterialLibrary := GLMaterialLibrary1;
      Cube.Material.LibMaterialName := 'Pozadina';
      // Dodajemo obojenu stranu
      Cube := TGLCube.CreateAsChild(Dummy);
      Cube.CubeDepth := 0.2;
      Cube.Parts := [cpBack];
      Cube.Material.MaterialLibrary := GLMaterialLibrary1;
      Cube.Material.LibMaterialName := IzaberiMaterijal;
    end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Randomize;
  // Postavlja polja na tablu
  NovaIgra;
  // Uzima material za "nestajanje" polja
  MatFade := GLMaterialLibrary1.LibMaterialByName('FadeOut').Material;
end;

procedure TForm1.GLSceneViewer1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  Obj: TGLCube;
begin
  // Ako se nesto desava druge ploce ne mogu da se izaberu
  if Okretanje or Vracanje or Nestajanje then Exit;
  Obj := TGLCube(GLSceneViewer1.Buffer.GetPickedObject(X, Y));
  // Uzimamo u obzir samo kocke
  if Obj <> nil then
  begin
    // Ako nismo izabrali ni jednu onda nam je ovo prva
    // i pocinjemo sa okretanjem
    if Izabrana1 = nil then
    begin
      // Parent od kocke koja je pozadina je DummyCube koja
      // sadrzi i pozadinu i boju pa kada rotiramo
      // DummyCube rotira se i pozadina i boja
      Izabrana1 := TGLDummyCube(Obj.Parent);
      Okretanje := True;
    end
    else
    // Ako je prva vec izabrana pazimo da je nismo izabrali
    // ponovo i ako nismo onda je izabrana i druga i
    // pocinjemo sa okretanjem
    if Izabrana1 <> Obj.Parent then
    begin
      Izabrana2 := TGLDummyCube(Obj.Parent);
      Okretanje := True;
    end;
  end;

end;

procedure TForm1.GLCadencer1Progress(Sender: TObject; const deltaTime,
  newTime: Double);
begin
 // Cekamo da istekne neko vreme
  if Pauza then
  begin
    Cekanje := Cekanje - deltaTime;
    if Cekanje < 0 then
      Pauza := False;
  end
  else
  // Vracamo polja ako su nisu ista
  if Vracanje then
  begin
    // Okrecemo polja
    Izabrana1.TurnAngle := Izabrana1.TurnAngle + 500 * deltaTime;
    Izabrana2.TurnAngle := Izabrana1.TurnAngle + 500 * deltaTime;
    // Ako se polje okrenulo skroz (ili mozda malo vise)
    // resetujemo rotacije i vracanje je gotovo
    if Izabrana1.TurnAngle < 0 then
    begin
      Izabrana1.ResetRotations;
      Izabrana2.ResetRotations;
      Izabrana1 := nil;
      Izabrana2 := nil;
      Vracanje := False;
    end;
  end
  else
  // Sklanjamo polja sa table ako su ista
if Nestajanje then
begin
  // Smanjujemo alpha vrednost tako da pozadina postaje sve
  // providnija
  MatFade.FrontProperties.Diffuse.Alpha :=
    MatFade.FrontProperties.Diffuse.Alpha - 1 * deltaTime;
  // Smanjujemo alpha vrednost tako da boja postaje sve
  // providnija
  MatBoja.FrontProperties.Diffuse.Alpha :=
    MatBoja.FrontProperties.Diffuse.Alpha - 1 * deltaTime;
  // Malo da vrtimo polja dok nestaju ;)
  Izabrana1.Turn(1000 * deltaTime);
  Izabrana2.Turn(1000 * deltaTime);
  Izabrana1.Position.Z:=Izabrana1.Position.Z+(deltaTime * 2);
  Izabrana2.Position.Z:=Izabrana2.Position.Z+(deltaTime * 2);
  // Ako je sve nevidnjivo brisemo polja
  if MatFade.FrontProperties.Diffuse.Alpha <= 0 then
  begin
    Izabrana1.Free;
    Izabrana2.Free;
    Izabrana1 := nil;
    Izabrana2 := nil;
    // Vracamo ponovo alpha na 1
    MatFade.FrontProperties.Diffuse.Alpha := 1;
    MatBoja.FrontProperties.Diffuse.Alpha := 1;
    Nestajanje := False;
    // Nema vise polja... nova igra!?
    if Tabla.Count = 0 then
      if Application.MessageBox('Nova igra?', 'Info', MB_ICONQUESTION+MB_YESNO) = ID_YES then
        NovaIgra
      else
        Application.Terminate;
  end;
end  else
  // Okrecemo izabrano polje
  if Okretanje then
  begin
    // Vec smo izabrali drugo polje
    if Izabrana2 <> nil then
    begin
      // Okrecemo ga
      Izabrana2.TurnAngle := Izabrana2.TurnAngle + 500 * deltaTime;
      // Okrenuo se na zeljenu stranu (ili mozda malo vise)
      if Izabrana2.TurnAngle < 0 then
      begin
        // Resetujemo rotacije i postavljamo tacnu vrednost
        // koju zelimo
        Izabrana2.ResetRotations;
        Izabrana2.Turn(180);
        // Okretanje je zavrseno i pocinje pauza da igrac
        // vidi sta je uradio
        Okretanje := False;
        Pauza := True;
        Cekanje := 0.5;
        // Proveravamo da li su polja ista
        Proveri;
      end;
    end
    else
    begin
      // Okrecemo prvo polje
      Izabrana1.TurnAngle := Izabrana1.TurnAngle + 500 * deltaTime;
      if Izabrana1.TurnAngle < 0 then
      begin
        Izabrana1.ResetRotations;
        Izabrana1.Turn(180);
        Okretanje := False;
      end;
    end;
  end;

end;

end.
